#include <MailTab.h>
#include <hwTableLayout.h>
#include <hwScrollWindow.h>
#include <hwTable.h>
#include <hwButtonbar.h>
#include <hwLabel.h>
#include <hwText.h>
#include <hwTree.h>
#include <ComposeDialog.h>
#include <hwWindow.h>
#include <hwCheckbox.h>

class mailButtonbar : public hwButtonbar
{
public:
    mailButtonbar(ComposeDialog* d) : myComposeDialog(d) {}
    void onClick() {
        if (getStringValue() == "New") {
            myComposeDialog->show();
        }
    }
private:
    ComposeDialog* myComposeDialog;
};

MailTab::MailTab(hwWindow* window)
: myWindow(window)
{
    myComposeDialog = new ComposeDialog(myWindow);
    
    hwTableLayout* tablelayout1 = new hwTableLayout();
    add(tablelayout1);

    tablelayout1->add(new hwLabel("Folders"), 0, 0);

    hwScrollWindow* scrollwindow2 = new hwScrollWindow();
    scrollwindow2->setName("mailFolderScrollWindow");
    tablelayout1->add(scrollwindow2, 1, 0);

    myFolderTree = new hwTree();
    scrollwindow2->add(myFolderTree);
    
    hwTableLayout* tablelayout2 = new hwTableLayout();
    add(tablelayout2);

    mailButtonbar* buttonbar1 = new mailButtonbar(myComposeDialog);
    buttonbar1->add("New");
    buttonbar1->add("Delete");
    buttonbar1->add("Reply");
    buttonbar1->add("Reply All");
    buttonbar1->add("Forward");
    buttonbar1->add("Junk");
    tablelayout2->add(buttonbar1, 0, 0);

    hwScrollWindow* scrollwindow1 = new hwScrollWindow();
    scrollwindow1->setName("mailMessageScrollWindow");
    tablelayout2->add(scrollwindow1, 1, 0);

    myMessageTable = new hwTable();
    myMessageTable->setColumnLabel(0, new hwLabel(""));
    myMessageTable->setColumnLabel(1, new hwLabel("Subject"));
    myMessageTable->setColumnLabel(2, new hwLabel("From"));
    myMessageTable->setColumnLabel(3, new hwLabel("Size"));
    myMessageTable->setColumnLabel(4, new hwLabel("Received"));

    scrollwindow1->add(myMessageTable);

    hwText* text1 = new hwText();
    text1->setName("mailText");
    tablelayout2->add(text1, 2, 0);
    
    loadFolders();
    loadMessageTable();
}

void MailTab::loadFolders()
{
    hwLabel* label1 = new hwLabel("Account1");
    myFolderTree->addNode(label1, new hwLabel("Inbox"));
    myFolderTree->addNode(label1, new hwLabel("Draft"));
    myFolderTree->addNode(label1, new hwLabel("Sent"));
    myFolderTree->addNode(label1, new hwLabel("Trash"));
    myFolderTree->addNode(label1, new hwLabel("Junk"));
}

void MailTab::loadMessageTable()
{
    myMessageTable->setValue(0, 0, new hwCheckbox(""));
    myMessageTable->setValue(0, 1, new hwLabel("How's it going?"));
    myMessageTable->setValue(0, 2, new hwLabel("bob@gmail.com"));
    myMessageTable->setValue(0, 3, new hwLabel("1000KB"));
    myMessageTable->setValue(0, 4, new hwLabel("Feb 19 10:00am"));
    
    myMessageTable->setValue(1, 0, new hwCheckbox(""));
    myMessageTable->setValue(1, 1, new hwLabel("Hell from Vegas!"));
    myMessageTable->setValue(1, 2, new hwLabel("joe@gmail.com"));
    myMessageTable->setValue(1, 3, new hwLabel("1250KB"));
    myMessageTable->setValue(1, 4, new hwLabel("Feb 20 9:00am"));
}

void MailTab::loadMessage()
{
}


