#ifndef HWSERVER_H
#define HWSERVER_H

#include <string>
#include <vector>
#include <map>
#include <pthread.h>

using namespace std;

class hwApp;
class MD5;
class wsRequest;

class hwServer
{
public:

    static hwServer* getInstance();

    void run(unsigned int port);
    
	void process(wsRequest* request);

    void setAppFactory(hwApp* app)
        { myAppFactory = app; }
        
    hwApp* getThreadApp(pthread_t thread);
    
    void threadDone(pthread_t thread);
    
private:

    hwServer();
    
    static void* process(void* data);
    string createKey(const string& s);
    
    hwApp* myAppFactory;
    map<string,hwApp*> myAppMap;
    map<unsigned long,hwApp*> myThreadMap;
    static hwServer* myInstance;
    pthread_mutex_t myMutex1;
    pthread_mutex_t myMutex2;
    MD5* myMD5;
};

#endif
