#ifndef HWWIDGET_H
#define HWWIDGET_H

#include <string>
#include <iostream>
#include <pthread.h>

using namespace std;

class hwServer;

class hwWidget
{
    friend class hwServer;
    
public:

    virtual ~hwWidget();

    virtual string draw() = 0;

    string getName() const 
        { return myName; }

	virtual void onClick();
    
    void setValue(const string& value)
        { myValue = value; }
        
    void setName(const string& name);
    
    string getValue() const 
        { return myValue; }
	
protected:

    hwWidget(const string& classname);
    
	string myName;
    string myValue;
    string myClass;
	
private:

    static void init();
    
    hwWidget(const hwWidget& source);
    hwWidget& operator=(const hwWidget& source);

    static pthread_mutex_t myMutex;    
    static unsigned long myWidgetCounter;
};

#endif

