#ifndef WS_REQUEST_H
#define WS_REQUEST_H

#include <string>
#include <map>
#include <vector>

using namespace std;

class wsRequest
{
public:
    
    wsRequest(int socket);
    
    ~wsRequest();
    
    string getParam(const string& param)
        { return myParamVals[param]; }
    
    vector<string> getParamList()
        { return myParamList; }

    void output(const string& data);
    
    void setCookie(const string& key, const string& val)
        { myResponseVals["Set-Cookie"] = key + "=" + val; }
    
private:

    void parseQuery(const string& query);
    
    string toLower(const string& s);
    
    string strip(const string& s);
    
    string decode(const string& s);
    
    map<string,string> myHeaderVals;
    map<string,string> myParamVals;
    map<string,string> myResponseVals;
    string myContent;
    vector<string> myParamList;
    int mySocket;
    
};

#endif
