#ifndef WS_SERVER_H
#define WS_SERVER_H

#include <string>
#include <map>

#ifdef WIN32
#include <windows.h>
#include <winsock2.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#endif

using namespace std;

class wsRequest;

class wsServer
{
public:
    
    typedef void (*handler)();
    
    wsServer(unsigned int port);
    
    wsRequest* getRequest();
    
    void addHandler(const string& url, handler h)
        { myHandlers[url] = h; }
        
private:
    
    unsigned int myPort;
    int mySocket;
    sockaddr_in myAddr;
    map<string,handler> myHandlers;
};

#endif

