#include <hwApp.h>
#include <hwWindow.h>
#include <hwServer.h>
#include <hwTheme.h>
#include <hwWidget.h>
#include <hwScrollWindow.h>
#include <vector>
#include <string>
#include <iostream>
#include <wsRequest.h>

hwApp::hwApp()
: myClass("hwApp")
{
}

hwApp::~hwApp()
{
}

void hwApp::process(wsRequest* request)
{
    /* Update any values */
    
    vector<string> params = request->getParamList();
    
    for (int i = 0; i < params.size(); i++)
    {
        hwWidget* w = myWidgetMap[params[i]];
        
        if (w)
        {
            w->setValue(request->getParam(params[i]));
        }
    }
    
    /* Process any callbacks */
    
	string widget = request->getParam("_widget");
    hwWidget* w = myWidgetMap[widget];

	if (w)
	{
    	string event = request->getParam("_event");
        
        if (event == "click")
        {
    	    w->onClick();
        }
	}
	
    /* Generate output html */
    
    string iframe = request->getParam("_iframe");

    string html;
    
    if (iframe.size())
    {
        hwScrollWindow* sw = (hwScrollWindow*)myWidgetMap[iframe];
        html = sw->drawChild();
    }
    else
    {
        html = myActiveWindow->draw();
    }
	
	request->output(html);
    
    delete request;
    
    hwServer::getInstance()->threadDone(pthread_self());
}

void hwApp::registerWidget(hwWidget* w)
{
    if (w)
    {
        myWidgetMap[w->getName()] = w;
    }
}


