#include <hwTabLayout.h>
#include <stdlib.h>
#include <sstream>
#include <hwApp.h>

hwTabLayout::hwTabLayout()
: hwWidget("hwTabLayout")
{
    myValue = "0";
}

hwTabLayout::~hwTabLayout()
{
	
}

string hwTabLayout::draw()
{
	string html;
	
	html = "<table class=\"hwTabLayout\" cellspacing=\"0\" id=\"" + 
        myName + "\" name=\"" + myName + "\">";

	html += "<tr class=\"hwTabLayoutTabRow\"><td>";
    html += "<table><tr class=\"hwTabLayoutTabRow\">";
    
    unsigned int index = atoi(myValue.c_str());
	
	for (unsigned int i = 0; i < myChildList.size(); i++)
	{
        stringstream s;
        
        s << i;

        html += (i == index) ? 
            "<td id=\"selected\" class=\"tab\">" : "<td class=\"tab\">";
    
		html += "<a href=?_widget=" + myName + "&" + myName + "=" + s.str() + 
            "&_event=click onclick=\"this.form.submit()\">" + 
            myChildList[i]->label + "</a>";
            
        html += "</td>";
	}

    html += "</tr></table>";
    html += "</td></tr>";

    if (myChildList.size() > 0)
    {
        html += "<tr><td>";
        
        html += "<div class=\"hwTabLayoutContentRow\">";
        
        if (myChildList[index]->widget)
        {
            html += myChildList[index]->widget->draw();
        }
        
        html += "</div>";
        html += "</td></tr>";
    }
	
	html += "</table>";
		
	return html;
}

void hwTabLayout::add(
	const string& label,
	hwWidget* widget
)
{
	child_t* child = new child_t;
	child->label = label;
	child->widget = widget;
	myChildList.push_back(child);
}

