#include <hwTable.h>
#include <hwLabel.h>

hwTable::hwTable()
: hwWidget("hwTable")
{
}

hwTable::~hwTable()
{
}

string hwTable::draw()
{
	string html = "<table class=\"hwTable\" id=\"" + myName + "\" name=\"" + myName + "\">";
    
    html += "<tr>";
    
    for (unsigned int i = 0; i < myCols.size(); i++)
    {
        html += "<th>";
        html += myCols[i] ? myCols[i]->draw() : "&nbsp;";
        html += "</th>";
    }
    
    html += "</tr>";
    
    for (unsigned int i = 0; i < myCells.size(); i++)
    {
        html += "<tr>";
        
        for (unsigned int j = 0; j < myCells[i].size(); j++)
        {
            html += "<td>";
            html += myCells[i][j] ? myCells[i][j]->draw() : "&nbsp;";
            html += "</td>";
        }
        
        html += "</tr>";
    }
    
    html += "</table>";
	
	return html;
}

void hwTable::setValue(
    unsigned int row, 
    unsigned int col, 
    hwWidget* w
)
{
    while (myCells.size() < (row + 1))
    {
        vector<hwWidget*> cols;
        myCells.push_back(cols);
    }
    
    while (myCells[row].size() < (col + 1))
    {
        myCells[row].push_back(NULL);
    }
    
    myCells[row][col] = w;
}

void hwTable::setColumnLabel(
    unsigned int col,
    hwLabel* label
)
{
    while (myCols.size() < (col + 1))
    {
        myCols.push_back(NULL);
    }
    
    myCols[col] = label;
}

hwWidget* hwTable::getValue(
    unsigned int row,
    unsigned int col
    )
{
    hwWidget* val = NULL;
    
    if (myCells.size() && (row < myCells.size()))
    {
        if (myCells[row].size() && (col < myCells[row].size()))
        {
            val = myCells[row][col];
        }
    }
    
    return val;
}

void hwTable::clear()
{
    for (unsigned int i = 0; i < myCells.size(); i++)
    {
        for (unsigned int j = 0; j < myCells[i].size(); j++)
        {
            if (myCells[i][j])
            {
                delete myCells[i][j];
            }
        }
        
        myCells[i].clear();
    }
    
    myCells.clear();
}

