#include <hwTree.h>

hwTree::hwTree()
: hwWidget("hwTree"), myRoot(NULL)
{
}

void hwTree::addNode(
    hwWidget* parent,
    hwWidget* child
)
{
    if (parent && child)
    {
        if (!myRoot)
        {
            myRoot = parent;
        }
        
        if (myNodes.find(parent) == myNodes.end())
        {
            vector<hwWidget*> v;
            v.push_back(child);
            myNodes[parent] = v;
        }
        else
        {
            myNodes[parent].push_back(child);
        }
    }
}

string hwTree::draw()
{
    string html;
    
    if (myRoot)
    {
        html = drawNode(myRoot);
    }

    return html;
}

string hwTree::drawNode(hwWidget* node)
{
    string html;
    
    vector<hwWidget*>::iterator iter = myNodes[node].begin();
    
    html = "<ul>";
    
    while (iter != myNodes[node].end())
    {
        html += "<li>";
        html += (*iter)->draw();
        html += "</li>";
        
        if (myNodes.find(*iter) != myNodes.end())
        {
            if (myNodes[*iter].size())
            {
                html += drawNode(*iter);
            }
        }
        
        iter++;
    }
    
    html += "</ul>";
    
    return html;
}

