#include <hwWindow.h>
#include <hwApp.h>
#include <hwTheme.h>
#include <sstream>
#include <hwServer.h>

hwWindow::hwWindow()
: hwWidget("hwWindow")
{
}

hwWindow::hwWindow(const string& classname)
: hwWidget(classname)
{
}

hwWindow::~hwWindow()
{
}

string hwWindow::draw()
{
    string html;

	html += "<html>";
	html += "<head>";
    html += "<style>";
	html += hwServer::getInstance()->getThreadApp(pthread_self())->getTheme()->getStyle();
    html += "</style>";
	html += "</head>";
	html += "<body>";
	html += "<form method=\"post\" name=\"" + myName + "\">";
	html += "<input type=\"hidden\" name=\"_event\">";
	html += "<input type=\"hidden\" name=\"_widget\">";
    html += "<table class=\"hwWindow\" id=\"" + myName + "\" name=\"" + myName + "\">";
    html += "<tr class=\"hwWindowTitlebar\"><td>" + myTitle + "</td></tr>";
    html += "<tr class=\"hwWindowContent\"><td>";
	html += myChild ? myChild->draw() : "";
    html += "</td></tr>";
    html += "</table>";
	html += "</form>";
	html += "</body>";
    html += "</html>";

    return html;
}


