#include <wsServer.h>
#include <wsRequest.h>
#include <iostream>
#include <string.h>

wsServer::wsServer(unsigned int port)
: myPort(port)
{
#ifdef WIN32
    WORD ver;
    WSADATA data;
    WSAStartup(ver, &data);
#endif

    int result;
    int one = 1;
    
    memset(&myAddr, 0, sizeof(myAddr));
    
    mySocket = socket(AF_INET, SOCK_STREAM, 0);
    
    setsockopt(mySocket, SOL_SOCKET, SO_REUSEADDR, 
        (const char*)&one, sizeof(one));
        
    myAddr.sin_family = AF_INET;
    myAddr.sin_addr.s_addr = INADDR_ANY;
    myAddr.sin_port = htons(myPort);
    
    result = bind(mySocket, (struct sockaddr*)&myAddr, sizeof(myAddr));
    
    if (result == -1)
    {
        cerr << "Unable to bind socket to port " << port << endl;
        return;
    }
    
    listen(mySocket, 100);   
}

wsRequest* wsServer::getRequest()
{
    int addr_length = sizeof(myAddr);
    int client;

#ifdef WIN32
        client = accept(mySocket, (sockaddr*)&myAddr, (int*)&addr_length);
#else
        client = accept(mySocket, (sockaddr*)&myAddr, (socklen_t*)&addr_length);
#endif

    return new wsRequest(client);
}

