#include <wsStringTokenizer.h>

wsStringTokenizer::wsStringTokenizer(string str, string myDelim)
{
    if ((str.length() == 0) || (myDelim.length() == 0))
    {
        return;
    }

    myTokenStr = str;
    this->myDelim = myDelim;

    unsigned int currentPos = 0;

    while(true)
    {
        if ((currentPos = myTokenStr.find(myDelim,currentPos)) != string::npos)
        {

            currentPos +=myDelim.length();
            while(myTokenStr.find(myDelim,currentPos) == currentPos)
            {

                myTokenStr.erase(currentPos,myDelim.length());

            }
        }
        else
            break;
    }

    if (myTokenStr.find(myDelim,0) == 0)
    {
        myTokenStr.erase(0,myDelim.length());
    }

    currentPos = 0;
    
    if ((currentPos = myTokenStr.rfind(myDelim)) != string::npos)
    {
        if (currentPos != (myTokenStr.length()-myDelim.length()))
            return;
        myTokenStr.erase(myTokenStr.length()-myDelim.length(),myDelim.length());
    }
}

int wsStringTokenizer::countTokens()
{
    unsigned int prevPos = 0;
    int numTokens = 0;

    if (myTokenStr.length() > 0)
    {
        numTokens = 0;

        unsigned int currentPos = 0;
        
        while(true)
        {
            if ((currentPos = myTokenStr.find(myDelim,currentPos)) != string::npos)
            {
                numTokens++;
                prevPos     = currentPos;
                currentPos += myDelim.length();
            }
            else
                break;
        }

        return ++numTokens;
    }
    else
    {
        return 0;
    }
}

bool wsStringTokenizer::hasMoreTokens()
{
    return (myTokenStr.length() > 0);
}

string wsStringTokenizer::nextToken()
{
    if (myTokenStr.length() == 0)
    {
        return "";
    }

    string tStr ="";
    unsigned int pos  = myTokenStr.find(myDelim,0);

    if (pos != string::npos)
    {
        tStr     = myTokenStr.substr(0,pos);
        myTokenStr = myTokenStr.substr(pos+myDelim.length(),myTokenStr.length()-pos);

    }
    else
    {
        tStr = myTokenStr.substr(0,myTokenStr.length());
        myTokenStr = "";

    }

    return tStr;
}

int  wsStringTokenizer::nextIntToken()
{
    return atoi(nextToken().c_str());
}

double wsStringTokenizer::nextFloatToken()
{
    return atof(nextToken().c_str());
}

string wsStringTokenizer::nextToken(string myDelimiter)
{
    if (myTokenStr.length() == 0)
    {
        return "";
    }

    string tStr ="";
    unsigned int pos = myTokenStr.find(myDelimiter,0);

    if (pos != string::npos)
    {
        tStr = myTokenStr.substr(0,pos);
        myTokenStr = myTokenStr.substr(pos+myDelimiter.length(),myTokenStr.length()-pos);
    }
    else
    {
        tStr = myTokenStr.substr(0,myTokenStr.length());
        myTokenStr = "";
    }

    return tStr;
}

string wsStringTokenizer::remainingString()
{
    return  myTokenStr;
}

string wsStringTokenizer::filterNextToken(string filterStr)
{
    string str = nextToken();
    unsigned int currentPos = 0;

    while((currentPos = str.find(filterStr,currentPos)) != string::npos)
    {
        str.erase(currentPos,filterStr.length());
    }

    return str;
}
